<template>
  <div class="mb-3">
    <select
      v-model="input"
      :class="{'error-field': error}"
      :required="required"
      class="shadow appearance-none border rounded
      w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
      @change="validateInput"
      @input="$emit('update:modelValue', $event.target.value)"
    >
      <option
        v-for="option of options"
        :key="option.key"
        :value="option.key"
      >
        {{ option.value }}
      </option>
    </select>
    <div v-if="error" class="ui basic label pointing red error-text">
      {{ error }}
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, toRefs } from 'vue';

export default defineComponent({
  name: 'SelectField',
  props: {
    value: {
      type: [Boolean, String],
      default: null,
    },
    options: {
      type: Array,
      default: undefined,
    },
    id: {
      type: [String, Number],
      default: null,
    },
    defaultValue: {
      type: String,
      default: null,
    },
    defaultName: {
      type: String,
      default: null,
    },
    type: {
      type: String,
      default: 'text',
    },
    placeholder: {
      type: String,
      default: null,
    },
    regExp: {
      type: String,
      default: null,
    },
    required: {
      type: Boolean,
      default: false,
    },
    toggleValidForm: {
      type: Function,
      required: true,
    },
  },
  setup(props) {
    const input = ref('');
    const error = ref('');
    const { required, toggleValidForm } = toRefs(props);

    const validateInput = () => {
      if (required && !input.value) {
        error.value = 'The Field is required';
        toggleValidForm.value(false);

        return;
      }

      error.value = '';
      toggleValidForm.value(true);
    };

    return { input, error, validateInput };
  },
});
</script>

<style scoped>

</style>
